import {
  providers
} from "./chunk-3UIWA75U.js";

// src/hooks/connectkit/injectProviders.ts
import fs from "fs-extra";
import path from "path";
var injectProviders = ({
  envNamespace,
  envPrefix
}) => ({
  async beforeInstall({ context, targetPath }) {
    const { providerNames } = context.get();
    const configPath = path.join(targetPath, "src", "wagmi.ts");
    let src = fs.readFileSync(configPath).toString();
    src = src.replace(
      /([\s\S]*getDefaultClient[\s\S]*)(\s\s}\),)([\s\S]*)/,
      (_, a, _b, c) => {
        return a + providerNames.map((providerName) => {
          const provider = providers[providerName];
          if (!provider.apiKey)
            return "";
          return `    ${provider.name}Id: ${envNamespace}.${envPrefix}${provider.apiKey.env}!,
`;
        }).join("") + "  })" + c;
      }
    );
    fs.writeFileSync(configPath, src);
  }
});

export {
  injectProviders
};
